Point[] ps;
Link link;
long lastTime = 0;

void setup() {
  size(640, 360);
  
  // prepare geometry
  ps = new Point[]{new Point(new PVector(100, 50), 1), new Point(new PVector(200, 50), 1)};
  link = new Link();
  link.p0 = 0;
  link.p1 = 1;
  link.k = 10;
  link.l = PVector.sub(ps[link.p0].p, ps[link.p1].p).mag();

  lastTime = millis();
}

void draw() {
  background(0);

  long now = millis();
  float delta = (now - lastTime) / 1000.f;
  lastTime = now;
  
  // spring force
  // F = -(l - l0) * k * dir / |dir|
  PVector dir = PVector.sub(ps[link.p1].p, ps[link.p0].p);
  float l = dir.mag();
  PVector f = PVector.div(PVector.mult(dir, (l - link.l) * link.k), l);
  
  ps[0].resetForce();
  ps[0].applyAcceleration(new PVector(0, 100));
  ps[0].applyForce(f);

  ps[0].update(delta);
  
  ps[0].draw();
  ps[1].draw();
  
  
}
